module Index.Index where

import Datentypen
import PlandowskiUnif.Plandowski (plandowski)
import Debug.Trace
import Data.List
import Chomsky (chomsky,umwandeln_sub)
import ProdPreOrder.Funktionen (pruefrechts,getLength_prod,traverse_prefix,traverse_suffix)



----------------------index (ProdPreOrder (P "A_t") [F"g",P"B",P"A"]) (ProdPreOrder (P "A_s") [F"g",P"A",P"A"])  beispiel1 1---------------------------
index :: ProdPre -> ProdPre -> [ProdPre] -> Integer -> [ProdPre] -> Integer
index x y prods zaehler lliste = 

                          let --in lliste befinden sich die längen der Nonterminale
                              --länge von x und y
                              getlx         = (getLength_prod x lliste)
                              getly         = (getLength_prod y lliste)
                              w             = (min getlx getly)
                              m             = (div w 2)
                              prefix_x      = (traverse_prefix (x) (prods++[x,y]) (m)         (zaehler)   (ProdPreOrder (P "s") [])) lliste 0
                              prefix_y      = (traverse_prefix (y) (prods++[x,y]) (m)         (zaehler+1) (ProdPreOrder (P "s") [])) lliste 0
                              lenprefix_x   = (ProdPreOrder (P (show zaehler)) [Laenge m])
                              lenprefix_y   = (ProdPreOrder (P (show (zaehler+1))) [Laenge m])
                              suffix_x      = (traverse_suffix (x) (prods++[x,y]) (getlx - m) (zaehler)   (ProdPreOrder (P "s") [])) lliste 0
                              suffix_y      = (traverse_suffix (y) (prods++[x,y]) (getly - m) (zaehler+1) (ProdPreOrder (P "s") [])) lliste 0
                              lensuffix_x   = (ProdPreOrder (P (show zaehler)) [Laenge (getlx - m)])
                              lensuffix_y   = (ProdPreOrder (P (show (zaehler+1))) [Laenge (getly - m)])
                              chomsk        = (chomsky ([prefix_x]++[prefix_y]++prods) (zaehler+2))
                              pruefR        = pruefrechts prefix_x prefix_y
                              prodint       = prelen_in_prodlen lliste
                              prodgenprefix = [(prodpre_in_prodgen prefix_x m),(prodpre_in_prodgen prefix_y m)]
                              plandows      = plandowski (fst chomsk) (snd chomsk) (prodint++prodgenprefix) [(N ("P"++show zaehler), N ("P"++show (zaehler+1)))] in

                          if w == 1
                          then 1
                          else
                          if pruefR
                          then 
                            --trace ("PREFIXE---1:------------"++show prefix_x++"--------------------"++show prefix_y++"--------"++show m)
                            --trace ("SUFFIXE---1:------------"++show suffix_x++"------------------- "++show suffix_y++"--------"++show m)
                            (m + (index suffix_x suffix_y prods (zaehler+2) (lliste++[lensuffix_x,lensuffix_y])))
                          else
                          if plandows == False
                          then --trace ("PREFIXE---2:---------"++show prefix_x++"--------------"++show prefix_y++"---------"++show m)
                               index prefix_x prefix_y prods (zaehler+2) (lliste++[lenprefix_x,lenprefix_y])
                          else 
                               --trace ("SUFFIXE---2:-------"++show suffix_x++"----------------"++show suffix_y++"--------"++show m)
                               (m + (index suffix_x suffix_y prods (zaehler+2) (lliste++[lensuffix_x,lensuffix_y])))




prelen_in_prodlen :: [ProdPre]->[ProdGen]
prelen_in_prodlen x = prelen_in_prodlen_sub x

prelen_in_prodlen_sub::[ProdPre]->[ProdGen]
prelen_in_prodlen_sub []                          = []
prelen_in_prodlen_sub ((ProdPreOrder y [Laenge i]):xs)  = case y of 
                                                (P a)          ->   (ProdInt (N ("P"++a)) (i)):prelen_in_prodlen_sub xs
                                                (L a)          ->   (ProdInt (N ("L"++a)) (i)):prelen_in_prodlen_sub xs
                                                (R a)          ->   (ProdInt (N ("R"++a)) (i)):prelen_in_prodlen_sub xs
                                                otherwise      ->   error "unerlaubte Produktion"



prodpre_in_prodgen :: ProdPre -> Integer -> ProdGen
prodpre_in_prodgen (ProdPreOrder a b) laenge = case a of 
                                        (P a)     ->   (ProdInt (N ("P"++a)) (laenge))
                                        (L a)     ->   (ProdInt (N ("L"++a)) (laenge))
                                        (R a)     ->   (ProdInt (N ("R"++a)) (laenge))
                                        otherwise ->   error "unerlaubte Produktion"

getLinksprod :: ProdPre -> Symbol
getLinksprod (ProdPreOrder a b) = case a of
                                  (P a)          ->   (N ("P"++a))
                                  (L a)          ->   (N ("L"++a))
                                  (R a)          ->   (N ("R"++a))
                                  otherwise      ->   error "unerlaubte Produktion"