module P_ext.P_ext where

import Datentypen
import Beispiele
import Debug.Trace
import Position.Wordlength (wordLength_pos)
import Position.Funktionen (traverse_suffix_pos,getProd_pos,umwandeln,getLength_pos)
import STG.Funktionen (runterbrechen,getProd_stg,getLength_stg,length1,drop1)
import ProdPreOrder.Funktionen (traverse_prefix,getProd)
import Index.Index (getLinksprod,prelen_in_prodlen,prodpre_in_prodgen)
import PlandowskiUnif.Plandowski (plandowski)
import Chomsky (chomsky)



p_ext :: [STG_Prod] -> STG_Prod -> Position -> [Position] -> Integer -> Integer -> [STG_Pre_Symbol] -> [STG_Prod] -> ([STG_Prod],STG_Prod,Integer,[STG_Prod])
p_ext stgprods (STG_Prod (a) (as)) (Pos (p) ps) posprods zaehler zaehler2 erstesn2 lengstg =
           let
               lliste  = wordLength_pos posprods
               prelen  = (umwandeln lliste)
               prodpre = (umwandeln posprods)
               prodint = prelen_in_prodlen prelen
               lp      = (getLength_pos p lliste)
               a''     = head(umwandeln [(Pos (p) ps)])
               tnn     = (TN ("N'-"++show zaehler2))
               erstn2  = head erstesn2
               dummy2  = (Pos (PT "p") [])
               lenga   = (getLength_stg a lengstg)
               lengn2  = (getLength_stg erstn2 lengstg)
           in

           if lambda (Pos (p) ps) posprods lliste || ps==[]
           then case a of 
                     TN l -> (stgprods++[(STG_Prod tnn [a])],(STG_Prod tnn [a]),zaehler2,lengstg++[(STG_Prod tnn [Laenge lenga])])
                     CN l -> (stgprods++[(STG_Prod tnn [a,erstn2])],(STG_Prod tnn [a,erstn2]),zaehler2,lengstg++[(STG_Prod tnn [Laenge (lenga+lengn2)])])

           else 
            case as of
                    [CN c1, n2]  -> let 
                                        prod           = (getProd_stg (CN c1) stgprods)
                                        hprod          = (getProd_pos (H c1) posprods)
                                        hprodpre       = (getProd (L c1) prodpre)
                                        lHc1           = (getLength_pos (H c1) lliste)
                                        l_1            = (lHc1 - lp)
                                        l_2            = (lp - lHc1)
                                        dummy1         = (STG_Prod (CN "a") [])
                                        dummy3         = (ProdPreOrder (P "h") [])
                                        suff1          = traverse_suffix_pos hprod posprods l_1 zaehler dummy2 lliste 0
                                        suff2          = traverse_suffix_pos (Pos (p) (ps)) posprods l_2 zaehler dummy2 lliste 0
                                        a'             = traverse_prefix a'' prodpre lHc1 (zaehler+1) dummy3 prelen 0
                                        b'             = traverse_prefix hprodpre prodpre lp (zaehler+1) dummy3 prelen 0
                                        prodgenprefix  = [(prodpre_in_prodgen b' lp)]
                                        prodgenprefix' = [(prodpre_in_prodgen a' lHc1)]
                                        chomsk         = (chomsky ([b']++prodpre) 2)
                                        chomsk'        = (chomsky ([a']++prodpre) 2)
                                        plandow        = plandowski (fst chomsk)  (snd chomsk)  (prodint++prodgenprefix)  [((N (wandleum p)), N ("P"++show (zaehler+1)))]
                                        plandow'       = plandowski (fst chomsk') (snd chomsk') (prodint++prodgenprefix') [((N (wandleum (H c1))), N ("P"++show (zaehler+1)))]
                                        abfrage        = if plandow'==True
                                                         then 
                                                         p_ext stgprods (getProd_stg (n2) stgprods) (fst suff2) ([(fst suff2)]++posprods) (snd suff2) zaehler2 (erstesn2++[n2]) lengstg
                                                         else
                                                         p_ext stgprods prod (Pos (p) ps) posprods zaehler zaehler2 (erstesn2++[n2]) lengstg

                                     in

                                     if lp<lHc1 && plandow==True
                                     then
                                         let
                                           w       = (pos_in_sym (fst suff1) zaehler2)
                                           v       = (pos_in_prod (fst suff1) stgprods zaehler2 (lengstg++[wleng]))
                                           v'''    = (third1 v)
                                           n''     = (STG_Prod tnn [w,n2])
                                           np      = ([n'']++(first1 v)++stgprods)
                                           wleng   = (STG_Prod w [Laenge v'''])
                                           n2leng  = (getLength_stg n2 lengstg)
                                           n''leng = (STG_Prod tnn [Laenge (v'''+n2leng)])
                                         in 
                                      (np,n'',zaehler2,(lengstg++[n''leng]++(second1 v)))
                                      else abfrage

                    ((F f):ns)   ->   let
                                          suff2  = traverse_suffix_pos (Pos (p) (ps)) (posprods) (lp - 1) (zaehler) dummy2 lliste 0
                                          comp1  = (comp (Pos (p) (ps)) ns posprods a)
                                      in

                                      if fst(comp1)
                                      then p_ext stgprods (getProd_stg (snd comp1) stgprods) (fst suff2) ([(fst suff2)]++posprods) (snd suff2) zaehler2 erstesn2 lengstg
                                      else error "Module P_ext , Funktion p_ext case"
                    [X x]        -> (([STG_Prod tnn [a]]++stgprods),(STG_Prod (a) (as)),zaehler2,lengstg++[(STG_Prod tnn [Laenge lenga])])
                    [K x]        -> (([STG_Prod tnn [a]]++stgprods),(STG_Prod (a) (as)),zaehler2,lengstg++[(STG_Prod tnn [Laenge lenga])])
                    [TN b]       -> p_ext stgprods (getProd_stg (TN b) stgprods) (getProd_pos (head ps) posprods) posprods zaehler zaehler2 erstesn2 lengstg
                    otherwise    -> error ("In any other case pExt (G,(STG_Prod "++show a++"-->"++show as++"),(Pos "++show p++"-->"++show ps++",P) is undifined")

first1  (x,y,z) = x
second1 (x,y,z) = y
third1  (x,y,z) = z

comp:: Position -> [STG_Pre_Symbol] -> [Position] -> STG_Pre_Symbol-> (Bool,STG_Pre_Symbol)
comp (Pos _ [])      ns posprods b = (True,b)
comp (Pos _ (p:pos)) ns posprods b = case p of
                                Z a       -> (True,getSTG_Pre_Symbol a ns)
                                otherwise -> comp (getProd_pos p posprods) ns posprods b

getSTG_Pre_Symbol :: Integer -> [STG_Pre_Symbol] -> STG_Pre_Symbol
getSTG_Pre_Symbol i liste = head (drop1 (i-1) liste)


pos_in_prod :: Position -> [STG_Prod] -> Integer -> [STG_Prod] -> ([STG_Prod],[STG_Prod],Integer)
pos_in_prod (Pos (PT a) x) stgprods zaehler lengstg =
 let
    cnp  = (CN ("PT "++a++"-"++show zaehler))
    cnp1 = (CN ("PT "++a++"*"++show zaehler))
 in
 case x of
        [H b, H c] -> let 
                         len1    = getLength_stg (CN b) lengstg
                         len2    = getLength_stg (CN c) lengstg
                         len_1_2 = len1 + len2
                      in

                      ([(STG_Prod cnp [CN b, CN c])],[(STG_Prod cnp [Laenge len_1_2])],len_1_2)

        [H b]      -> let 
                         len1 = getLength_stg (CN b) lengstg
                         hl   = (hole_loch stgprods)
                      in

                      if fst hl
                      then ([(STG_Prod cnp [CN b, (snd hl)])],[(STG_Prod cnp [Laenge len1])],len1)
                      else ([(STG_Prod cnp [CN b,cnp1]),(STG_Prod cnp1 [Loch])],[(STG_Prod cnp [Laenge len1]),(STG_Prod cnp1 [Laenge 0])],len1)

        otherwise  -> let
                         n_u = (nenne_um x)
                         sum = (foldl (+) 0 (calclen n_u lengstg))
                      in
                      runterbrechen zaehler (STG_Prod cnp n_u) [] ("PT "++a++"*"++show zaehler) sum lengstg


calclen :: [STG_Pre_Symbol] -> [STG_Prod] -> [Integer]
calclen x lengstg = calclen_sub x lengstg []

calclen_sub :: [STG_Pre_Symbol] -> [STG_Prod] -> [Integer] -> [Integer]
calclen_sub (x:xs) ys sum = calclen_sub xs ys (calclen_sub' x ys sum)
calclen_sub []     ys sum = sum

calclen_sub':: STG_Pre_Symbol -> [STG_Prod] -> [Integer] -> [Integer]
calclen_sub' x [] sum = sum
calclen_sub' x ((STG_Prod a [Laenge b]):ys) sum = if x==a
                                                  then [b]
                                                  else calclen_sub' x ys sum

hole_loch :: [STG_Prod] -> (Bool,STG_Pre_Symbol)
hole_loch []     = (False,error "Kein Loch vorhanden!") 
hole_loch (x:xs) = case x of
                   (STG_Prod (CN b) [Loch]) -> (True,CN b)
                   otherwise                -> hole_loch xs

nenne_um :: [Pos_Symbol] -> [STG_Pre_Symbol]
nenne_um []     = []
nenne_um (x:xs) = case x of 
                         (H b) -> CN b : nenne_um xs
                         (PT b)-> TN b : nenne_um xs


pos_in_sym :: Position -> Integer -> STG_Pre_Symbol
pos_in_sym (Pos (PT a) x) zaehler = (CN ("PT "++a++"-"++show zaehler))


wandleum:: Pos_Symbol -> String
wandleum a = case a of
                 (PT a) -> "P"++a
                 (H a)  -> "L"++a
                 (Z a)  -> "T"++(show a)
                 otherwise -> error "Module p_ext.p_ext , Funktion wandleum"

lambda::Position -> [Position] -> [Position] -> Bool
lambda (Pos (p) [])     posprods lliste  = True
lambda (Pos (p) [ps])   posprods lliste  = if (getLength_pos ps lliste)>1
                                           then False
                                           else lambda (getProd_pos ps posprods) posprods lliste

lambda (Pos (p) (x:xs)) posprods lliste  = False
