module PlandowskiSTG_Prod.Plandowski2 where

import Datentypen
import Beispiele
import Data.List



split_in_two :: [Prod] -> [ProdGen] -> [ProdGen] -> ([ProdGen],[ProdGen])
split_in_two [] mengeN mengeT = (mengeN, mengeT)
split_in_two ((Produktion (N a) [N b, N c]):xs) mengeN mengeT = split_in_two xs ((ProdSymSym (N a) (N b , N c)):mengeN) mengeT
split_in_two ((Produktion (N a) [T b]):xs) mengeN mengeT = split_in_two xs mengeN ((ProdInt (N a) (1)):mengeT)

-- O(n)
termSubst::[ProdGen]->ProdGen->[ProdGen]->[ProdGen] -> ([ProdGen],[ProdGen])
termSubst [] x ns_neu ts_neu = (ns_neu, ts_neu)
termSubst (ProdSymSym (N a) (N b, N c):ns) (ProdInt (N d) (n)) ns_neu ts_neu
        | (b==d && c/=d)        = termSubst ns (ProdInt (N d) (n)) ([ProdIntSym (N a) (n,N c)] ++ ns_neu) ts_neu
        | (b/=d && c==d)        = termSubst ns (ProdInt (N d) (n)) ([ProdSymInt (N a) (N b,n)] ++ ns_neu) ts_neu
        | (b==d && c==d)        = termSubst ns (ProdInt (N d) (n)) ns_neu ([ProdInt (N a) (n+n)] ++ ts_neu)
        | otherwise             = termSubst ns (ProdInt (N d) (n)) ([ProdSymSym (N a) (N b, N c)] ++ ns_neu) ts_neu
termSubst (ProdIntSym (N a) (b, N c):ns) (ProdInt (N d) (n)) ns_neu ts_neu
        | (c==d)                = termSubst ns (ProdInt (N d) (n)) ns_neu ([ProdInt (N a) (b+n)]++ts_neu)
        | otherwise             = termSubst ns (ProdInt (N d) (n)) ([ProdIntSym (N a) (b, N c)]++ns_neu) ts_neu
termSubst (ProdSymInt (N a) (N b, c):ns) (ProdInt (N d) (n)) ns_neu ts_neu
        | (b==d)                = termSubst ns (ProdInt (N d) (n)) ns_neu ([ProdInt (N a) (c+n)]++ts_neu)
        | otherwise             = termSubst ns (ProdInt (N d) (n)) ([ProdSymInt (N a) (N b, c)]++ns_neu) ts_neu

-- O(n^2)
--wordLength::[Prod] -> ([ProdGen],[ProdGen])
wordLength::[Prod] -> [ProdGen]
wordLength xs = let spl = split_in_two xs [] [] in
                snd (wordLengthCalc spl (snd spl))

wordLengthCalc::([ProdGen],[ProdGen]) -> [ProdGen] -> ([ProdGen],[ProdGen])
wordLengthCalc ([],ts_neu) ts = ([],ts_neu)
wordLengthCalc (ns,ts_neu) [] = wordLengthCalc (ns,ts_neu) ts_neu
wordLengthCalc (ns,ts_neu) (x:ts) = wordLengthCalc (termSubst ns x [] ts_neu) ts


-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------ÜBERPRÜFUNG DER TESTMENGE-------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------

--O(n)
substN :: ProdGen -> [(Symbol,Symbol)] ->  [(Symbol,Symbol)] -> [(Symbol,Symbol)] -> ([(Symbol,Symbol)],[(Symbol,Symbol)])
substN x [] ns_neu ss_neu = (ns_neu,ss_neu)
substN (ProdInt (N a) (n)) ((N b, N c):xs)  ns_neu ss_neu
     | (b==a && c/=a) = substN (ProdInt (N a) (n)) xs ([(I n, N c)]++ns_neu) ss_neu
     | (b/=a && c==a) = substN (ProdInt (N a) (n)) xs ([(N b, I n)]++ns_neu) ss_neu
     | (a==b && a==c) = substN (ProdInt (N a) (n)) xs  ns_neu ([(I n, I n)]++ss_neu)
     | otherwise      = substN (ProdInt (N a) (n)) xs  ns_neu ss_neu
substN (ProdInt (N a) (n)) ((I b, N c):xs) ns_neu ss_neu
     | (a==c && n==b) = substN (ProdInt (N a) (n)) xs ns_neu ([(I b, I n)]++ss_neu)
     | otherwise      = substN (ProdInt (N a) (n)) xs ns_neu ss_neu
substN (ProdInt (N a) (n)) ((N b, I c):xs) ns_neu ss_neu
     | (a==b && n==c) = substN (ProdInt (N a) (n)) xs ns_neu ([(I n, I c)]++ss_neu)
     | otherwise      = substN (ProdInt (N a) (n)) xs ns_neu ss_neu

 
compareLength_sub :: [ProdGen] -> [(Symbol,Symbol)] -> [(Symbol,Symbol)] -> [(Symbol,Symbol)] -> [(Symbol,Symbol)]
compareLength_sub (x:ns) ss ss_neu testmenge = compareLength_sub ns (fst(substN x ss [] []) ++ ss) (snd(substN x ss [] [])++ss_neu) testmenge   
compareLength_sub [] ss ss_neu testmenge =  if length(ss_neu) == length(testmenge) then testmenge
                                            else []
--O(n^2)
compareLength :: [ProdGen] -> [(Symbol,Symbol)] -> [(Symbol,Symbol)]
compareLength (x:ns) testmenge = compareLength_sub (x:ns) testmenge [] testmenge
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------ÜBERPRÜFUNG DER TESTMENGE-------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------



-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------INITIALISIERUNG DER MENGE REL------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
--O(n)
createRel :: [(Symbol,Symbol)] -> [(Symbol,Symbol,Symbol)]
createRel [] = []
createRel ((N a, N b):xs) = (N a, N b ,I 0) : createRel xs

-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------INITIALISIERUNG DER MENGE REL------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------



-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------PRODUKTIONEN MIT DEREN LÄNGE------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------

--O(n)
prod_length_sub':: Prod -> [ProdGen] -> [(Prod,ProdGen)]-> [(Prod,ProdGen)]
prod_length_sub' (Produktion (N a) [N b, N c]) [] temp = temp
prod_length_sub' (Produktion (N a) [N b, N c]) ((ProdInt (N d) (n):xs)) temp
                    | (a==d) = [(Produktion (N a) [N b, N c],ProdInt (N d) ( n))]++temp
                    | (a/=d) = prod_length_sub' (Produktion (N a) [N b, N c]) xs temp
prod_length_sub' (Produktion (N a) [T b]) ((ProdInt (N d) (n)):ns) temp
                    | (a==d) = [(Produktion (N a) [T b],ProdInt (N d) ( n))]++temp
                    | (a/=d) = prod_length_sub' (Produktion (N a) [T b]) ns temp

--O(n^2)
prod_length_sub :: [Prod] -> [ProdGen]-> [(Prod,ProdGen)] -> [(Prod,ProdGen)]
prod_length_sub (x:xs) ys temp = prod_length_sub xs ys (prod_length_sub' x ys []++temp)
prod_length_sub [] ys temp = temp

--O(2n^2)
prod_length :: [Prod] -> [ProdGen] -> [(Prod,ProdGen)]
prod_length x y = prod_length_sub x y [] 


-- --O(n^2)
qsort_length :: [(Prod,ProdGen)] -> [(Prod,ProdGen)]
qsort_length [] = []
qsort_length ((x,ProdInt (N d) (n)):xs) = qsort_length [(x,ProdInt (N d) (y)) | (x,ProdInt (N d) (y)) <- xs , y>n ] ++ [(x,ProdInt (N d) (n))] ++ qsort_length [(x,ProdInt (N d) (y)) | (x,ProdInt (N d) (y)) <- xs , y<=n ]


-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------PRODUKTIONEN MIT DEREN LÄNGE------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------



-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------LÄNGE FÜR NICHTTERMINAL AUS PRODUKTIONEN---------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
--O(n)
getLength :: Symbol -> [ProdGen] -> Integer
getLength (N x) ((ProdInt (N z) (n)):xs) = if x==z then n else getLength (N x) xs


-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------LÄNGE FÜR NICHTTERMINAL AUS PRODUKTIONEN---------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------




-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------DIE OPERATION COMPACTREL--------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------




---------da unser rel immer lexikalisch sortiert ist, funktioniert das mit dem drop
compactRel :: [(Symbol,Symbol,Symbol)] -> [ProdGen] -> [(Symbol,Symbol,Symbol)] -> [(Symbol,Symbol,Symbol)]
compactRel [] lliste rel_nach_compact = rel_nach_compact
compactRel [x] lliste rel_nach_compact = ([x] >+> rel_nach_compact)
compactRel [x,y] lliste rel_nach_compact = ([x,y] >+> rel_nach_compact)
compactRel ((T x, N y, I z):xs) lliste rel_nach_compact = compactRel xs lliste ([(T x, N y, I z)] >+> rel_nach_compact)
compactRel ((N x, T y, I z):xs) lliste rel_nach_compact = compactRel xs lliste ([(N x, T y, I z)] >+> rel_nach_compact)
compactRel ((T x, T y, I z):xs) lliste rel_nach_compact = compactRel xs lliste ([(T x, T y, I z)] >+> rel_nach_compact)
compactRel ((N x, N y, I z):y1:y2:xs) lliste rel_nach_compact =
 case y1 of
 (N a, N b, I c) -> case y2 of
                   (N k, N l, I m) -> if x/=a
                                      then compactRel ((N a, N b, I c):(N k, N l, I m):xs) lliste [(N x, N y, I z)]>+>rel_nach_compact
                                      else
                                      if x==a && x/=k
                                      then compactRel ((N k, N l, I m):xs) lliste [(N x, N y, I z),(N a, N b, I c)]>+>rel_nach_compact
                                      else
                                      if x==a && x==k && y/=b
                                      then compactRel ((N a, N b, I c):(N k, N l, I m):xs) lliste [(N x, N y, I z)]>+>rel_nach_compact
                                      else
                                      if x==a && x==k && y==b && y/=l
                                      then compactRel ((N k, N l, I m):xs) lliste [(N x, N y, I z),(N a, N b, I c)]>+>rel_nach_compact
                                      else
                                      if ((x==a && x==k && y==b && y==l) && (((c-z) + (m-z)) <= ((getLength (N a) lliste)-z)) && ((z<c) && (c<m)))
                                      then [(N x, N y, I z),(N x, N y, I (gcd (c-z) (m-z)))] >+> rel_nach_compact
                                      else
                                      compactRel xs lliste [(N x, N y, I z),(N a, N b, I c),(N k, N l, I m)]>+>rel_nach_compact
                   otherwise       -> compactRel xs lliste ([(N x, N y, I z),y1,y2] >+> rel_nach_compact)
 otherwise      -> compactRel (y2:xs) lliste ([(N x, N y, I z),y1] >+> rel_nach_compact)


-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------DIE OPERATION COMPACTREL--------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------




-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------DIE OPERATION SPLIT-----------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------


split :: (Prod,ProdGen) -> [(Symbol,Symbol,Symbol)] -> [ProdGen] -> [(Symbol,Symbol,Symbol)] -> [(Symbol,Symbol,Symbol)]
split (x,y) [] k rel_neu = compactRel rel_neu k []
split v (w:xs) lliste rel_neu =
--1.FALL-------------------------------------------------------------------------------------------------------------------------------------------------------------------
 case v of
 (Produktion (N a) [N e, N f],ProdInt (N g) (n)) -> let  -- Länge von N e
                                                         lne = (getLength (N e) lliste)
                                                         lnf = (getLength (N f) lliste) in
      case w of
      (N b, N c, I i) ->      let  -- Länge von N e
                                   lnb = (getLength (N b) lliste)
                                   lnc = (getLength (N c) lliste) in

        if (a/=b && a/=c)
        then split v xs lliste ([w] >+> rel_neu) 
        else
             if (a==b && a/=c) 
             then 
                      if (lne > i) 
                      then 
                                if ((lnc + i) > lne) 
                                then (split v xs lliste ([(N e,N c,I i),(N c,N f,I(lne-i))]>+>rel_neu))
                                else (split v xs lliste ([(N e,N c, I i)]>+>rel_neu))
                      else
                                if (lne == i) 
                                then
                                               if (lnc > lnf) 
                                               then (split v xs lliste ([(N f, N c, I 0)]>+>rel_neu))
                                               else (split v xs lliste ([(N c, N f, I 0)]>+>rel_neu))

                                else (split v xs lliste ([(N f, N c, I (i - lne))]>+>rel_neu))


             else 
                      if (a/=b && a==c)  
                      then 
                                if (lne + i) < lnb 
                                then 
                                        let rel' = ([(N b, N e, I i),(N b, N f, I (lne + i))] >+> rel_neu)
                                        in (split v xs lliste rel') 
                                else (split v xs lliste ([(N b, N e, I i)] >+> rel_neu))
                      else 
                                if (a==b && a==c)
                                then 
                                                 if (i==0) 
                                                 then (split v xs lliste rel_neu)
                                                 else
                                                               if ((lne > i) && (i >= 1)) 
                                                               then 
                                                                          if (i < lnf) 
                                                                          then (split v xs lliste ([(N e, N e, I i),(N f, N f, I i),(N e, N f, I (lne - i))] >+> rel_neu))
                                                                          else (split v xs lliste ([(N e,N e, I i),(N e, N f, I (lne-i))] >+> rel_neu))

                                                               else
                                                                          if (lne == i) 
                                                                          then 
                                                                                        if (lne < lnf) 
                                                                                        then (split v xs lliste ([(N f, N e, I 0),(N f, N f,I i)] >+> rel_neu))
                                                                                        else (split v xs lliste ([(N e, N f, I 0)] >+> rel_neu))

                                                                          else

                                                                                        if (lne < i ) 
                                                                                        then 

                                                                                                   if (i < lnf) 
                                                                                                   then (split v xs lliste ([(N f, N e, I (i - lne)),(N f, N f, I i)] >+> rel_neu))
                                                                                                   else (split v xs lliste ([(N f, N e,I (i - lne))] >+> rel_neu))

                                                                                        else rel_neu
                                 else error "Split 1.Fall darf nicht eintreten"

--2.Fall---------------------------------------------------------------------------------------------------------------------------------------------------------------------

      (T b, N c, I i) ->

       if (a/=c)
       then split v xs lliste ([w] >+> rel_neu)
       else
               if (a==c)
               then
                         if (lne + i) >= 1
                         then (split v xs lliste ([(T b, N e, I i)] >+> rel_neu))
                         else (split v xs lliste ([(T b, N e, I i),(T b, N f, I (lne + i))] >+> rel_neu))
               else error "Split 2. Fall"
--3.Fall-------------------------------------------------------------------------------------------------------------------------------------------------------------------------

      (N b, T c, I i) ->

       if (a/=b)
       then split v xs lliste ([w] >+> rel_neu)
       else
                 if (a==b)
                 then 
                            if (lne > i)
                            then
                                          if (i + 1) > lne
                                          then (split v xs lliste ([(N e,T c,I i),(T c,N f,I(lne-i))] >+> rel_neu))
                                          else (split v xs lliste ([(N e,T c, I i)] >+> rel_neu))
                            else
                                          if (lne == i)
                                          then
                                                          if (1 > lnf)
                                                          then (split v xs lliste ([(N f, T c, I 0)] >+> rel_neu))
                                                          else (split v xs lliste ([(T c, N f, I 0)] >+> rel_neu))
                                          else (split v xs lliste ([(N f, T c, I (i - lne))] >+> rel_neu))
                 else error "Split 3. Fall"

---4.Fall-------------------------------------------------------------------------------------------------------------------------------------------------------------------------

      (T b, T c, I i) ->    split v xs lliste rel_neu

---5.Fall-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 (Produktion (N a) [T e], ProdInt (N g) (n)) -> case w of 
      (N b, N c, I i) -> let  -- Länge von N e
                              lnb = (getLength (N b) lliste)
                              lnc = (getLength (N c) lliste) in

       if (a/=b && a/=c)
       then split v xs lliste ([w] >+> rel_neu)
       else
               if (a==b && a/=c)
               then
                         if (i < 1)
                         then
                                     if ((lnc + i) > 1)
                                     then (split v xs lliste ([(T e,N c,I i),(N c,T e,I (1-i))] >+> rel_neu))
                                     else (split v xs lliste ([(T e,N c, I i)] >+> rel_neu))
                         else

                                     if (i == 1)
                                     then
                                                     if (lnc <= 1)
                                                     then (split v xs lliste ([(N c, T e, I 0)] >+> rel_neu))
                                                     else (split v xs lliste ([(T e, N c, I 0)] >+> rel_neu))
                                     else (split v xs lliste ([(T e, N c, I (i - 1))] >+> rel_neu))


              else
                         if (a/=b && a==c)
                         then
                                     if (i + 1) >= lnb
                                     then (split v xs lliste ([(N b, T e, I i)] >+> rel_neu))
                                     else (split v xs lliste ([(N b, T e, I i),(N b, T e, I (1 + i))] >+> rel_neu))
                         else
                                     if (a==b && a==c)
                                     then
                                                    if (i == 0)
                                                    then (split v xs lliste rel_neu)
                                                    else
                                                                 if (i == 1)
                                                                 then (split v xs lliste ([(T e, T e, I 0)] >+> rel_neu))
                                                                 else
                                                                               if (i > 1)
                                                                               then (split v xs lliste ([(T e, T e,I (i - 1))] >+> rel_neu))
                                                                               else rel_neu

                                    else error "Split 5. Fall"
--6.Fall---------------------------------------------------------------------------------------------------------------------------------------------------------------------------

      (T b, N c, I i) ->

       if (a/=c)
       then split v xs lliste ([w] >+> rel_neu)
       else
                   if (a==c)
                   then
                                if (i + 1) >= 1
                                then (split v xs lliste ([(T b, T e, I i)] >+> rel_neu))
                                else (split v xs lliste ([(T b, T e, I i),(T b, T e, I (1 + i))] >+> rel_neu))
                   else error "Split 6. Fall"
---7.Fall------------------------------------------------------------------------------------------------------------------------------------------------------------------------

      (N b, T c, I i) ->

       if (a/=b)
       then split v xs lliste ([w] >+> rel_neu)
       else
                if (a==b)
                then
                          if (i < 1)
                          then (split v xs lliste ([(T e,T c, I i)] >+> rel_neu))
                          else
                                     if (i == 1)
                                     then (split v xs lliste ([(T c, T e, I 0)] >+> rel_neu))
                                     else
                                                    if (i > 1)
                                                    then (split v xs lliste ([(T e, T c, I (i - 1))] >+> rel_neu))
                                                    else rel_neu
                else error "Split 7. Fall"
---8.Fall----------------------------------------------------------------------------------------------------------------------------------------------------------------------

      (T b, T c, I i) ->  split v xs lliste ([w] >+> rel_neu)

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------




split_rek :: [(Prod,ProdGen)] -> [(Symbol,Symbol,Symbol)] -> [ProdGen] -> [(Symbol,Symbol,Symbol)]
split_rek [] rel lliste            = rel 
split_rek (x:sortiert) rel lliste  = split_rek sortiert ((split x rel lliste [])) lliste

split_rek_gen :: [ProdGen] -> [(Symbol,Symbol)] -> [(Prod,ProdGen)] -> [(Symbol,Symbol,Symbol)]
split_rek_gen lliste testmenge lpliste = let l   =  createRel testmenge
                                             --lpliste ist die liste der Produktionen mit deren Längen
                                             nts = (qsort_length lpliste)
                                         in  split_rek nts (sort $ l) lliste


-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------DIE OPERATION SPLIT-----------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------




(>+>) xs ys         = (<+>) xs ys
(<+>) :: (Eq a,Ord a) =>[a] -> [a] -> [a]
(<+>) [] ys      = ys
(<+>) (x:xs) ys  = xs <+> (insert_sorted x ys) 

insert_sorted :: (Eq a,Ord a) =>a -> [a]  -> [a]
insert_sorted y [] = [y]
insert_sorted y (x:xs)
 | not (is_sorted (x:xs)) = error "nicht sortiert"
 | y < x = y:x:xs
 | y > x  = x : (insert_sorted y xs)
 | otherwise = (x:xs)



is_sorted (x:y:xs) 
 | x < y  = is_sorted (y:xs)
 | otherwise = False

is_sorted _ = True





-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------PLANDOWSKI------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------

equal :: [(Symbol,Symbol,Symbol)] -> Bool
equal [] =  True
equal ((T x, T y, I z):xs) = (x==y && z==0 && equal xs)


plandowski :: [Prod] -> [(Symbol,Symbol)] -> Bool
plandowski grammar set= let -- Längen aller NT
                            lliste  = wordLength grammar
                            lpliste = prod_length grammar lliste
                            split   = (split_rek_gen lliste set lpliste)
                        in
                            if (compareLength lliste set) == []
                            then False
                            else
                                  if split == [] 
                                  then True
                                  else equal split




-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------PLANDOWSKI------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------

