module Posgrammar.Posgrammar where
import Index.Index (index)
import Datentypen
import Beispiele
import STG_in_SCFG.STG_in_SCFG (nurTN)
import Debug.Trace
import STG.Funktionen (split_in_two,finde_cn,getProd_stg,getLength_stg,drop1,take1,length1)
import STG.Wordlength (wordLength_stg)
import ProdPreOrder.Wordlength (wordLength)
import ProdPreOrder.Funktionen (getLength)


--testaufruf::   posgrammar (STG_Prod (TN "A_s") [F "g", TN "A", TN "A"] ) (STG_Prod (TN "A_t") [F "g", TN "B", TN "A"] ) beispiel
posgrammar:: STG_Prod -> [STG_Prod] -> [ProdPre] -> [STG_Prod] -> Integer -> (Position,[Position],Integer)
posgrammar a stgprods prodpre lliste indx = posgram a stgprods prodpre lliste indx


posgram :: STG_Prod -> [STG_Prod] -> [ProdPre] -> [STG_Prod] -> Integer -> (Position,[Position],Integer)
posgram x stgprods prodpre lliste k = let posgr = ppos x stgprods prodpre lliste k [] in
                                        ((last posgr),posgr++(hpos (snd(split_in_two stgprods)) [] ),k)

hpos :: [STG_Prod] -> [Position] -> [Position]
hpos [] hposition = hposition
hpos ((STG_Prod (CN p) xs):ys) hposition = case xs of 
                                           [Loch]      -> hpos ys ([(Pos (H p) [])]++hposition)
                                           [CN a,CN b] -> hpos ys ([(Pos (H p) [H a,H b])]++hposition)
                                           otherwise   -> let
                                                             fcn = (finde_cn xs 0)
                                                          in
                                                          hpos ys ([(Pos (H p) [Z (fst fcn),(snd fcn)])]++hposition) 



ppos :: STG_Prod -> [STG_Prod] -> [ProdPre] -> [STG_Prod] -> Integer -> [Position] -> [Position]
ppos (STG_Prod as axs) stgprods prelen lliste k posgrammatik =
      if k==1
      then
             case as of
                  TN a -> ([(Pos (PT ("TN"++"_"++a++","++"1")) [])]++posgrammatik)
                  CN a -> ([(Pos (PT ("CN"++"_"++a++","++"1")) [])]++posgrammatik)
                  otherwise -> error "Module Posgrammar, Funktion fukt (erstes case)"
      else
             case as of
                  TN z -> let
                              tn = ("TN"++"_"++z++","++(show k))
                          in
                          case axs of
                               [TN a,TN b] -> error "Falsche Eingabe: TN p -> TN a , TN b"
                               [CN a,CN b] -> error "Falsche Eingabe: TN p -> CN a , CN b"
                               [TN a,CN b] -> error "Falsche Eingabe: TN p -> TN a , CN b"
                               ((F a): xs) -> let
                                                 --liefert das NT des Arguments wo sich die Terme unterscheiden
                                                 gsumme   = (get_summe 1 xs k lliste prelen)
                                                 prod2    = (second gsumme)
                                                 prod3    = (thrd gsumme)
                                                 cnodertn = ((head (drop1 (prod2-1) xs)))
                                                 neuk     = (k-prod3)
                                                 gp       = (getProd_stg cnodertn stgprods)
                                              in
                                                 if nurTN xs
                                                 then
                                                            if first gsumme
                                                            then
                                                                    case cnodertn of
                                                                         TN v    -> let
                                                                                       tn' = ("TN"++"_"++v++","++(show neuk))
                                                                                    in
                                                                                    ppos gp stgprods prelen lliste neuk ([Pos (PT tn) [Z prod2,PT tn']]++posgrammatik)

                                                                         CN w    -> let
                                                                                       cn' = ("CN"++"_"++w++","++(show neuk))
                                                                                    in
                                                                                    ppos gp stgprods prelen lliste neuk ([Pos (PT tn) [Z prod2,PT cn']]++posgrammatik)
                                                                         otherwise -> error "Module Posgrammar, Funktion fukt (drittes case)"
                                                            else error "1.i ist in der Funktion get_summe über alle Elemente gelaufen und konnte die Bedingung(Fig.3)nicht erfüllen"
                                                 else error "TN kann auf der rechten Seite nur TN's besitzen"

                               [CN a,TN b] -> let
                                                 prod    = (getProd_stg (CN a) stgprods)
                                                 prod1   = (getProd_stg (TN b) stgprods)
                                                 laenge  = (getLength (L a) prelen)
                                                 laenge1 = (getLength_stg (TN b) lliste)
                                                 neuk    = (k-laenge1)
                                                 neuk'   = (k-laenge)
                                               in
                                                 if (1 < k)&&(k <= laenge)
                                                 then ppos prod stgprods prelen lliste k ([(Pos (PT tn) [PT ("CN"++"_"++a++","++(show k))])]++posgrammatik)
                                                 else
                                                          if ((laenge)<k) && (k <= laenge+laenge1)
                                                          then ppos prod1 stgprods prelen lliste neuk' ([(Pos (PT tn) [H a,PT ("TN"++"_"++b++","++(show neuk'))])]++posgrammatik)
                                                          else ppos prod  stgprods prelen lliste neuk  ([(Pos (PT tn) [PT ("CN"++"_"++a++","++(show neuk))])]++posgrammatik)

                               [TN b]      -> ppos (getProd_stg (TN b) stgprods) stgprods prelen lliste k ([(Pos (PT tn) [PT ("TN"++"_"++b++","++(show k))])]++posgrammatik)
                               otherwise   -> error (show as++"--->"++show axs)

                  CN z -> let
                             cn = ("CN"++"_"++z++","++(show k))
                          in
                          case axs of
                               [TN a,CN b] -> error "Falsche Eingabe: CN p -> TN a , CN b"
                               [CN a,TN b] -> error "Falsche Eingabe: CN p -> CN a , TN b"
                               [TN a,TN b] -> error "Falsche Eingabe: CN p -> TN a , TN b"
                               [Loch]      -> ([(Pos (PT ("CN"++"_"++z++","++(show k))) [])]++posgrammatik)
                               ((F a):xs)  -> let 
                                                 --liefert das NT des Arguments wo der Unterschied liegt 
                                                 gsumme   = (get_summe 1 xs k lliste prelen)
                                                 prod2    = (second gsumme)
                                                 prod3    = (thrd gsumme)
                                                 cnodertn = ((head (drop1 (prod2-1) xs)))
                                                 neuk     = (k-prod3)
                                                 gp       = (getProd_stg cnodertn stgprods)
                                              in
                                                 if first gsumme
                                                 then 
                                                        case cnodertn of
                                                             TN v    -> let
                                                                           tn' = ("TN"++"_"++v++","++(show neuk))
                                                                        in
                                                                        ppos gp stgprods prelen lliste neuk ([Pos (PT cn) [Z prod2,PT tn']]++posgrammatik)
                                                             CN w    -> let
                                                                           cn' = ("CN"++"_"++w++","++(show neuk))
                                                                        in
                                                                        ppos gp stgprods prelen lliste neuk ([Pos (PT cn) [Z prod2,PT cn']]++posgrammatik)
                                                             otherwise -> error "Module Posgrammar, Funktion fukt (viertes case)"
                                                 else error "2. i ist in der Funktion get_summe über alle Elemente gelaufen und konnte die Bedingung(Fig.3)nicht erfüllen"
                               [CN a,CN b] -> let 
                                                 prod    = (getProd_stg (CN a) stgprods)
                                                 prod1   = (getProd_stg (CN b) stgprods)
                                                 laenge  = (getLength (L a) prelen)
                                                 laenge1 = (getLength_stg (CN b) lliste)
                                                 neuk    = (k-laenge1)
                                                 neuk'   = (k-laenge)
                                              in
                                                if (1 < k)&&(k <= laenge) 
                                                then ppos prod stgprods prelen lliste k ([(Pos (PT cn) [PT ("CN"++"_"++a++","++(show k))])]++posgrammatik)
                                                else 
                                                         if (laenge<k) && (k <= laenge+laenge1)
                                                         then ppos prod1 stgprods prelen lliste neuk' ([(Pos (PT cn) [H a,PT ("CN"++"_"++b++","++(show neuk'))])]++posgrammatik)
                                                         else ppos prod  stgprods prelen lliste neuk  ([(Pos (PT cn) [PT ("CN"++"_"++a++","++(show neuk))])]++posgrammatik)
                               otherwise   -> error (show as++"--->"++show axs)

                  otherwise ->  error ("Die Linke Seite hat folgende Form:"++show as)



get_summe :: Integer -> [STG_Pre_Symbol] -> Integer -> [STG_Prod] -> [ProdPre] -> (Bool,Integer,Integer)
get_summe zaehler (x:xs) k lliste preliste = if zaehler > (length1 (x:xs)) 
                                             then (False,0,0)
                                             else
                                                        if zaehler==1 
                                                        then 
                                                                     if (1 < k) && (k<=(1+(getLength_stg (x) lliste)))
                                                                     then (True,1,1) 
                                                                     else get_summe (zaehler+1) (x:xs) k lliste preliste
                                                        else 
                                                                     let k'= foldl (+) (1) [(fukt4 y lliste preliste) | y <- (take1 (zaehler-1) (x:xs))]in
                                                                     if ((k' < k) && (k<=(k' + (fukt4 (head (drop1 (zaehler-1) (x:xs) )) lliste preliste))))
                                                                     then (True,zaehler,k')
                                                                     else get_summe (zaehler+1) (x:xs) k lliste preliste



fukt4 :: STG_Pre_Symbol -> [STG_Prod] -> [ProdPre] -> Integer
fukt4 y lliste preliste = case y of 
                               TN a -> getLength_stg y lliste
                               CN a -> getLength_stg y lliste
                               otherwise -> error "Funktion fukti in Posgrammar.hs"


first :: (a,b,b)->a
first (x,y,z) = x


second :: (a,b,b)->b
second (x,y,z) = y


thrd :: (a,b,b)->b
thrd (x,y,z) = z
