module STG.Funktionen where

import Datentypen

runterbrechen :: Integer -> STG_Prod -> [STG_Prod] -> String -> Integer -> [STG_Prod] -> ([STG_Prod],[STG_Prod],Integer)
runterbrechen zaehler (STG_Prod (CN a) (x:xs)) fuereinprodfertig string sum lengstg =
     if (length xs)==2 && (istenthalten xs fuereinprodfertig)
     then 
     ([(STG_Prod (CN a) [x, (getProd1 xs fuereinprodfertig)])]++fuereinprodfertig,lengstg,sum)
     else 
     if (length xs)==2
     then
     ([(STG_Prod (CN a) [x, (CN(string++"-"++show zaehler))]),(STG_Prod (CN(string++"-"++show zaehler)) xs)]++fuereinprodfertig,lengstg++[(STG_Prod (CN(string++"-"++show zaehler)) [Laenge (sum- (getLength_stg x lengstg))])],sum)
     else 
     runterbrechen (zaehler+1) (STG_Prod (CN(string++"-"++show zaehler)) xs) ([STG_Prod (CN a) [x,(CN(string++"-"++show zaehler))]]++fuereinprodfertig) string sum (lengstg++[(STG_Prod (CN(string++"-"++show zaehler)) [Laenge ((getLength_stg (CN a) lengstg)-(getLength_stg x lengstg))])])

istenthalten :: [STG_Pre_Symbol] -> [STG_Prod] -> Bool
istenthalten x [] = False
istenthalten x ((STG_Prod a liste):xs) = if x==liste then True
                                                          else istenthalten x xs

getProd1 :: [STG_Pre_Symbol] -> [STG_Prod] -> STG_Pre_Symbol
getProd1 x ((STG_Prod a liste):xs) = if x==liste then a
                                                 else getProd1 x xs


split_in_two :: [STG_Prod] -> ([STG_Prod],[STG_Prod])
split_in_two x = split_in_two_sub x [] []

split_in_two_sub :: [STG_Prod] -> [STG_Prod] -> [STG_Prod] -> ([STG_Prod],[STG_Prod])
split_in_two_sub [] pprods lrprods = (pprods,lrprods)
split_in_two_sub ((STG_Prod p xs):ys) pprods lrprods = case p of
                                                       (TN a)     -> split_in_two_sub ys ([(STG_Prod p xs)]++pprods) lrprods
                                                       otherwise  -> split_in_two_sub ys ([(STG_Prod p xs)]++pprods) ([(STG_Prod p xs)]++lrprods)

finde_cn :: [STG_Pre_Symbol] -> Integer -> (Integer,Pos_Symbol)
finde_cn (x:xs) zaehler = case x of 
                          CN a      -> error "Rechte Seite darf nicht mit CN anfangen" 
                          otherwise -> finde_cn_1 xs (zaehler+1)

finde_cn_1 :: [STG_Pre_Symbol] -> Integer -> (Integer, Pos_Symbol)
finde_cn_1 [] zaehler = error "Eingabe falsch: CN -> f(A1.........An) , ohne ein CN in den Argumenten!!!" 
finde_cn_1 (x:xs) zaehler = case x of 
                            CN a      -> (zaehler,(H a))
                            otherwise -> finde_cn_1 xs (zaehler+1)

getProd_stg :: STG_Pre_Symbol -> [STG_Prod] -> STG_Prod
getProd_stg x [] = error "Dieses Nonterminal hat keine Produktion"
getProd_stg x ((STG_Prod p liste):xs) = if p==x then (STG_Prod p liste)
                                            else getProd_stg x xs


getLength_stg :: STG_Pre_Symbol -> [STG_Prod] -> Integer
getLength_stg x y = getLength_stg_sub x y


getLength_stg_sub :: STG_Pre_Symbol -> [STG_Prod] -> Integer
getLength_stg_sub p [] = 0
getLength_stg_sub p ((STG_Prod k [Laenge x]):ys) =  case p of 
                                                    F x  -> 1
                                                    K x  -> 1
                                                    X x  -> 1
                                                    Loch -> 0
                                                    otherwise -> if p==k then x
                                                                         else getLength_stg_sub p ys

drop1 :: Integer -> [a] -> [a]
drop1 zaehler [] = []
drop1 zaehler (x:xs) =  if (zaehler==0) then x:xs
                                        else drop1 (zaehler-1) xs 

length1 :: [a] -> Integer
length1 []     = 0
length1 (x:xs) = 1+length1 xs

take1 :: Integer -> [a] -> [a]
take1 0 xs = []
take1 zaehler (x:xs) = x : take1 (zaehler-1) xs


ersetze_R :: STG_Pre_Symbol -> [STG_Prod] -> [STG_Prod]
ersetze_R (X x) [] = []
ersetze_R (X x) ((STG_Prod a b):ys) = case b of
                                     [X y]     -> if x==y then (STG_Prod a [TN x]) : ersetze_R (X x) ys
                                                          else (STG_Prod a b)      : ersetze_R (X x) ys
                                     otherwise -> (STG_Prod a b) : ersetze_R (X x) ys


getProd_R :: STG_Pre_Symbol -> [STG_Prod] -> [STG_Pre_Symbol]
getProd_R p [] = []
getProd_R p ((STG_Prod p1 ys):xs) = if p==p1 then ys
                                             else getProd_R p xs