module Unifikation.Unifikation where

import P_ext.P_ext (p_ext)
import Posgrammar.Posgrammar (posgrammar)
import Datentypen
import Beispiele
import Beispiele_neu
import Debug.Trace
import STG.Funktionen (ersetze_R,getProd_stg,getProd_R,getLength_stg)
import Index.Index (index,prelen_in_prodlen)
import STG_in_SCFG.STG_in_SCFG (transform_p)
import PlandowskiUnif.Plandowski (plandowski)
import Chomsky (chomsky)
import ProdPreOrder.Wordlength (wordLength)
import STG.Wordlength (wordLength_stg)
import Data.Either


----unifikationSTG bsp "A_t" "A_s"
--unifikationSTG :: STG -> TermNT -> TermNT -> Either String ([STG_Prod],[STG_Prod])
unifikationSTG grammatik nt1 nt2 = let
                                      stgprods = (convertSTGtoSTG_Prod grammatik)
                                      as       = (getP nt1 stgprods)
                                      at       = (getP nt2 stgprods)
                                   in

                                   case unifikation_sub stgprods as at [] 1 of
                                        Left err -> err
                                        Right x  -> (show ([stgprod_in_stg (fst x) []],[stgprod_in_stg (snd x) []]))

getP :: String -> [STG_Prod] -> STG_Prod
getP a ((STG_Prod b c):xs) = case b of
                                  TN d -> if a==d
                                          then (STG_Prod b c)
                                          else getP a xs
                                  CN d -> if a==d
                                          then (STG_Prod b c)
                                          else getP a xs
                                  otherwise -> error "Unerlaubter Typ auf der linken Seite einer Produktion !!! (Module Unifikation, Funktion getP)"

-----unifikation beispiel (STG_Prod (TN "A_t") [F "g", TN "B", TN "A"]) (STG_Prod (TN "A_s") [F "g", TN "A", TN "A"])
--unifikation :: [STG_Prod] -> STG_Prod -> STG_Prod -> Either String ([STG_Prod],[STG_Prod])
unifikation stgprods as at =
                              case unifikation_sub stgprods as at [] 1 of
                                        Left err -> err
                                        Right x  -> (show x)


-----unifikation_sub beispiel (STG_Prod (TN "A_t") [F "g", TN "B", TN "A"]) (STG_Prod (TN "A_s") [F "g", TN "A", TN "A"]) [] 1
unifikation_sub :: [STG_Prod] -> STG_Prod -> STG_Prod -> [STG_Prod] -> Integer -> Either String ([STG_Prod],[STG_Prod])
unifikation_sub stgprods as at unifikant zaehler = let lliste      = (wordLength_stg stgprods)
                                                       prelen      = (wordLength prodpre)
                                                       prodpre     = (transform_p stgprods)
                                                       prodint     = (prelen_in_prodlen prelen)
                                                       preas       = (head(transform_p [as]))
                                                       preat       = (head(transform_p [at]))
                                                       indx        = (index preas preat prodpre 1 prelen)
                                                       pas         = (posgrammar as stgprods prelen lliste indx)
                                                       pat         = (posgrammar at stgprods prelen lliste indx)
                                                       passtg      = (p_ext stgprods as (first1 pas) (second1 pas) 1 zaehler [] lliste)
                                                       patstg      = (p_ext stgprods at (first1 pat) (second1 pat) 1 zaehler [] lliste)
                                                       zaehlerNas  = (third passtg)
                                                       zaehlerNat  = (third patstg)
                                                       neulenstgas = (fourth passtg)
                                                       neulenstgat = (fourth patstg)
                                                       fstrootpas  = (fst(root(second passtg) [] (first passtg) neulenstgas))
                                                       fstrootpat  = (fst(root(second patstg) [] (first patstg) neulenstgat))
                                                       sndrootpas  = (snd(root(second passtg) [] (first passtg) neulenstgas))
                                                       sndrootpat  = (snd(root(second patstg) [] (first patstg) neulenstgat))
                                                       chomsk      = (chomsky prodpre 1)
                                                       plan        = plandowski (fst chomsk) (snd chomsk) prodint [(getLinks as, getLinks at)]
                                                       in

                             if plan
                             then
                             Right (stgprods,unifikant)
                             else
 
                             case fstrootpas of

                                  (F f) -> case fstrootpat of

                                           (F g)     -> if (g/=f)
                                                        then Left "Nicht unifizierbar, da die Funktionssymbole unterschiedlich sind!"
                                                        else Left "Ein root muss eine Variable sein!"

                                           (X x)     -> let nt         = (STG_Prod (TN x) [TN ("N'-"++show zaehlerNat)])
                                                            unifmenge_1= ([nt]++(ersetze_R (X x) (first passtg)))in

                                                        if occurs_check (X x) sndrootpas (first passtg) []
                                                        then Left "1.Nicht unifizierbar! Occurs Check!"
                                                        else unifikation_sub unifmenge_1 as at ([nt]++unifikant) (zaehler+1)
 

                                           otherwise -> Left "Nicht unifizierbar, ein Funktionssymbol kann nicht auf eine Konstante abgebildet werden! Mindestens ein root muss eine Variable sein!"



                                  (X x) -> case fstrootpat of

                                           (Loch)    -> Left "Nicht unifizierbar, eine Variable kann nicht auf ein Loch abgebildet werden! Keine first order Unifikation"

                                           (F g)     -> let nt         = (STG_Prod (TN x) [TN ("N'-"++show zaehlerNas)])
                                                            unifmenge_2= ([nt]++(ersetze_R (X x) (first patstg))) in
 
                                                        if occurs_check (X x) sndrootpat (first patstg) []
                                                        then Left "2.Nicht unifizierbar! Occurs Check!"
                                                        else unifikation_sub unifmenge_2 as at ([nt]++unifikant) (zaehler+1)



                                           otherwise -> let nt         = (STG_Prod (TN x) [TN ("N'-"++show zaehlerNas)])
                                                            unifmenge_2= ([nt]++(ersetze_R (X x) (first patstg))) in

                                                        if occurs_check (X x) sndrootpat (first patstg) []
                                                        then Left "3.Nicht unifizierbar! Occurs Check!"
                                                        else unifikation_sub unifmenge_2 as at ([nt]++unifikant) (zaehler+1)




                                  (Loch)-> Left "Nicht unifizierbar, auf ein Loch kann nichts abgebildet werden! Nicht unifizierbar! Keine first order Unifikation"



                                  otherwise-> case fstrootpat of

                                              (Loch) -> Left "Nicht unifizierbar, eine Konstante kann nicht auf ein Loch abgebildet werden! Keine first order Unifikation"

                                              (F g)  -> Left "Nicht unifizierbar, eine Konstante kann nicht auf ein Funktionssymbol abgebildet werden! Mindestens ein root muss eine Variable sein!"

                                              (K a)  -> Left "Nicht unifizierbar, eine Konstante kann nicht auf eine Konstante abgebildet werden! Mindestens ein root muss eine Variable sein!"

                                              (X x)  -> let nt         = (STG_Prod (TN x) [TN ("N'-"++show zaehlerNat)])
                                                            unifmenge_1= ([nt]++(ersetze_R (X x) (first passtg))) in

                                                        if occurs_check (X x) sndrootpas (first passtg) []
                                                        then Left "4.Nicht unifizierbar! Occurs Check!"
                                                        else unifikation_sub unifmenge_1 as at ([nt]++unifikant) (zaehler+1)



first  (x,y,z,l) = x
second (x,y,z,l) = y
third  (x,y,z,l) = z
fourth (x,y,z,l) = l

first1  (x,y,z) = x
second1 (x,y,z) = y

root :: STG_Prod -> [STG_Prod] -> [STG_Prod] -> [STG_Prod] -> (STG_Pre_Symbol,STG_Prod)
root (STG_Prod (TN a) [CN b, TN c]) kopf stgprods lliste = if (getLength_stg (CN b) lliste)==0
                                                           then root (getProd_stg (TN c) stgprods) (kopf++[(STG_Prod (TN a) [CN b, TN c])]) stgprods lliste
                                                           else root (getProd_stg (CN b) stgprods) (kopf++[(STG_Prod (TN a) [CN b, TN c])]) stgprods lliste
root (STG_Prod (CN a) [CN b, CN c]) kopf stgprods lliste = if (getLength_stg (CN b) lliste)==0
                                                           then root (getProd_stg (CN c) stgprods) (kopf++[(STG_Prod (TN a) [CN b, CN c])]) stgprods lliste
                                                           else root (getProd_stg (CN b) stgprods) (kopf++[(STG_Prod (TN a) [CN b, CN c])]) stgprods lliste
root (STG_Prod a (y:ys)) kopf stgprods lliste = case y of 
                                    (X x)     -> if kopf==[] then ((X x),(STG_Prod a (y:ys))) else ((X x),head kopf) 
                                    (K x)     -> if kopf==[] then ((K x),(STG_Prod a (y:ys))) else ((K x),head kopf)
                                    (F x)     -> if kopf==[] then ((F x),(STG_Prod a (y:ys))) else ((F x),head kopf)
                                    (Loch)    -> if kopf==[] then (Loch,(STG_Prod a (y:ys)))  else (Loch,head kopf)
                                    otherwise -> root (getProd_stg y stgprods) (kopf++[(STG_Prod a (y:ys))]) stgprods lliste

occurs_check :: STG_Pre_Symbol -> STG_Prod -> [STG_Prod] -> [STG_Pre_Symbol] -> Bool
occurs_check x (STG_Prod a [])     prods fertigen = False
occurs_check x (STG_Prod a (y:ys)) prods fertigen = if x == y
                                                    then True
                                                    else case y of
                                                             (X c)    -> occurs_check x (STG_Prod a ys) prods fertigen
                                                             (K c)    -> occurs_check x (STG_Prod a ys) prods fertigen
                                                             (F c)    -> occurs_check x (STG_Prod a ys) prods fertigen
                                                             Lambda   -> occurs_check x (STG_Prod a ys) prods fertigen
                                                             otherwise-> if elem y fertigen
                                                                         then occurs_check x (STG_Prod a ys) prods fertigen
                                                                         else occurs_check x (STG_Prod a (ys ++ (getProd_R y prods))) prods (fertigen++[y])

getLinks :: STG_Prod -> Symbol
getLinks (STG_Prod (TN a) b) = (N ("P"++a))
getLinks (STG_Prod (CN a) b) = error "Nur TERM-Nonterminale sind als Eingabe erlaubt !!!"